'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

exports.default = function (_ref) {
	var t = _ref.types;

	var optimizations = _optimizations2.default.map(function (f) {
		return f(t);
	});

	var visitor = {};
	var visitorMethods = {};

	// Split each optimization into its visitor methods and group
	// visitor methods together by name.
	optimizations.forEach(function (o) {
		for (var key in o) {
			if (visitorMethods[key]) {
				visitorMethods[key].push(o[key]);
			} else {
				visitorMethods[key] = [o[key]];
			}
		}
	});

	// Define the visitor methods, which call all optimization
	// methods found with that name.

	var _loop = function _loop(key) {
		visitor[key] = function (path, state) {
			visitorMethods[key].forEach(function (f) {
				return f(path, state);
			});
		};
	};

	for (var key in visitorMethods) {
		_loop(key);
	}

	return {
		visitor
	};
};

var _optimizations = require('./optimizations');

var _optimizations2 = _interopRequireDefault(_optimizations);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }